SystemOrganization addCategory: #'Glamour-Tests-Rubric'!

GLMMorphicTest subclass: #GLMRubricTextMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Rubric'!

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 11/10/2015 17:13'!
expectedFailures
	^ #(testUpdatingTextPortUpdatesTheMorph)! !

!GLMRubricTextMorphicTest methodsFor: 'private' stamp: 'TudorGirba 7/16/2013 21:52'!
simulateOnlyOneClickOn: aMorph
	(Delay forMilliseconds: HandMorph doubleClickTime + 1) wait.
	aMorph simulateClick! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 1/21/2016 16:20'!
testAcceptKeyCanBeOverriden
	| composite textMorph overriden |
	overriden := false.
	composite := GLMCompositePresentation new with: [ :a | a text act: [ :text | overriden := true ] on: $s entitled: 'Override'].
	window := composite openOn: '4'.
	textMorph := self find: RubScrolledTextMorph in: window.
	self simulateOnlyOneClickOn: textMorph.
	Smalltalk os isMacOSX ifTrue: [self simulateKeyStroke: $s command].
	Smalltalk os isUnix ifTrue: [self simulateKeyStroke: $s ctrl].
	Smalltalk os isWindows ifTrue: [self simulateKeyStroke: $s ctrl].
	self assert: overriden! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 10/30/2015 14:03'!
testEnteringTextInPort
	| composite textMorph |
	composite := GLMCompositePresentation new with: [ :a | a text display: '' ].
	window := composite openOn: 4.
	textMorph := self find: RubScrolledTextMorph in: window.
	self simulateOnlyOneClickOn: textMorph.
	self simulateKeyStrokes: 'hello'.
	self assert: (composite pane port: #text) value asString equals: 'hello'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 10/30/2015 14:03'!
testExplicitAcceptDoesNotAffectTextPort
	| composite textMorph |
	composite := GLMCompositePresentation new with: [ :a | a text display: '123' ].
	window := composite openOn: 4.
	textMorph := self find: RubScrolledTextMorph in: window.
	self simulateOnlyOneClickOn: textMorph.
	self simulateKeyStrokes: '4'.
	self assert: (composite pane port: #text) value asString equals: '1234'.
	self simulateKeyStroke: $s command.
	self simulateKeyStrokes: '56'.
	self assert: (composite pane port: #text) value asString equals: '123456'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 10/30/2015 14:03'!
testMultipleSelectionWithChange
	| composite textMorph textPresentation |
	composite := GLMCompositePresentation new with: [ :a | a text display: '123456789' ].
	window := composite openOn: 4.
	textMorph := self find: RubScrolledTextMorph in: window.
	self assert: textMorph selectionInterval isEmpty.
	textPresentation := composite presentations first.
	textPresentation selectionInterval: (2 to: 5).
	self assert: textMorph textArea selection asString equals: '2345'.
	self assert: textPresentation selectedText asString equals: '2345'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 1/24/2016 12:59'!
testOKeyWithCtrlCannotBeOverriden
	| composite textMorph overriden |
	overriden := false.
	composite := GLMCompositePresentation new with: [ :a | a text act: [ :text | overriden := true ] on: $o entitled: 'Override'].
	window := composite openOn: '4'.
	textMorph := self find: RubScrolledTextMorph in: window.
	self simulateOnlyOneClickOn: textMorph.
	Smalltalk os isMacOSX ifTrue: [self simulateKeyStroke: $o command].
	Smalltalk os isUnix ifTrue: [self simulateKeyStroke: $o ctrl].
	Smalltalk os isWindows ifTrue: [self simulateKeyStroke: $o ctrl].
	self assert: overriden not! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 10/30/2015 14:03'!
testPastingUpdatesTextPort
	| composite textMorph  |
	composite := GLMCompositePresentation new with: [ :a | a text display: '' ].
	window := composite openOn: 42.
	textMorph := self find: RubEditingArea in: window.
	Clipboard clipboardText: '42'.
	textMorph editor paste.
	self assert: (composite pane port: #text) value asString equals: '42'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 10/30/2015 14:03'!
testResettingTheSelection
	| composite textPresentation |
	composite := GLMCompositePresentation new with: [ :a | a text display: '123456789' ].
	window := composite openOn: 4.
	textPresentation := composite presentations first.
	textPresentation selectionInterval: (2 to: 5).
	self shouldnt: [textPresentation selectionInterval: nil] raise: Error! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 10/30/2015 14:03'!
testTextPortPopulatedByDefault
	| composite |
	composite := GLMCompositePresentation new with: [:a | a text ].
	window := composite openOn: '42'.
	self assert: (composite pane port: #text) value asString equals: '42'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 10/30/2015 14:03'!
testUnregisterFromAnnouncementsWhenUpdating
	| composite announcingCollection numberOfExecutions |
	numberOfExecutions := 0.
	announcingCollection := GLMAnnouncingCollection new.
	composite :=  GLMCompositePresentation new with: [ :a | 
					(a text)
						updateOn: GLMItemAdded from: [ announcingCollection ];
						display: [ 
								numberOfExecutions := numberOfExecutions + 1. 
								numberOfExecutions asString ] ].
	window := composite openOn: announcingCollection.
	1 to: 3 do: [ :each | announcingCollection add: each ].
	self assert: numberOfExecutions equals: 4	"it should not be 8"! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'AndreiChis 11/10/2015 17:12'!
testUpdatingTextPortUpdatesTheMorph
	| composite textMorph |
	composite := GLMCompositePresentation new with: [:a | a text ].
	window := composite openOn: 'fourtytwo'.
	composite first text: '42'.
	self assert: (composite pane port: #text) value asString equals: '42'.
	textMorph := self find: RubScrolledTextMorph in: window.
	self assert: textMorph text asString equals: '42'! !
